← All operations
POST/api/v1/agents/{entityPublicId}/inference/credentials

Runtime_CreateInferenceCredential

Authentication
required-user
Cache policy
none
Success and errors
201, 400, 401, 403, 404, 409, 422, 500
Stability
v1 stable contract

OpenAPI operation

{
  "operationId": "Runtime_CreateInferenceCredential",
  "summary": "POST /api/v1/agents/{entityPublicId}/inference/credentials",
  "tags": [
    "Runtime"
  ],
  "parameters": [
    {
      "name": "entityPublicId",
      "in": "path",
      "required": true,
      "schema": {
        "type": "string",
        "format": "uuid",
        "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
      }
    },
    {
      "name": "Idempotency-Key",
      "in": "header",
      "required": true,
      "schema": {
        "type": "string",
        "format": "uuid"
      }
    }
  ],
  "requestBody": {
    "required": true,
    "content": {
      "application/json": {
        "schema": {
          "type": "object",
          "properties": {
            "provider": {
              "type": "string",
              "enum": [
                "AMAZON_BEDROCK",
                "ANTHROPIC",
                "AZURE_OPENAI",
                "CEREBRAS",
                "COHERE",
                "DEEPINFRA",
                "FIREWORKS",
                "GOOGLE",
                "GOOGLE_VERTEX",
                "GROQ",
                "MISTRAL",
                "OPENAI",
                "OPENAI_COMPATIBLE",
                "OPENROUTER",
                "PERPLEXITY",
                "TOGETHER_AI",
                "XAI"
              ]
            },
            "label": {
              "type": "string",
              "minLength": 1,
              "maxLength": 120
            },
            "plaintext": {
              "type": "string",
              "minLength": 8,
              "maxLength": 100000
            },
            "compatibleBaseUrl": {
              "anyOf": [
                {
                  "type": "string",
                  "maxLength": 2048,
                  "format": "uri"
                },
                {
                  "type": "null"
                }
              ]
            },
            "providerConfig": {
              "default": {
                "modelIds": []
              },
              "type": "object",
              "properties": {
                "modelIds": {
                  "default": [],
                  "maxItems": 200,
                  "type": "array",
                  "items": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 500
                  }
                },
                "azureResourceName": {
                  "type": "string",
                  "pattern": "^[a-z0-9][a-z0-9-]{1,62}[a-z0-9]$"
                },
                "azureApiVersion": {
                  "type": "string",
                  "pattern": "^(?:v1|preview|\\d{4}-\\d{2}-\\d{2}(?:-preview)?)$"
                },
                "azureUseDeploymentBasedUrls": {
                  "type": "boolean"
                },
                "awsRegion": {
                  "type": "string",
                  "pattern": "^[a-z]{2}(?:-gov)?-[a-z]+-\\d$"
                },
                "googleProject": {
                  "type": "string",
                  "pattern": "^[a-z][a-z0-9-]{4,61}[a-z0-9]$"
                },
                "googleLocation": {
                  "type": "string",
                  "pattern": "^[a-z]+(?:-[a-z0-9]+)+$"
                }
              },
              "additionalProperties": false
            }
          },
          "required": [
            "provider",
            "label",
            "plaintext"
          ],
          "additionalProperties": false
        }
      }
    }
  },
  "security": [
    {
      "cookieAuth": []
    }
  ],
  "responses": {
    "201": {
      "description": "Success",
      "content": {
        "application/json": {
          "schema": {
            "type": "object",
            "additionalProperties": false,
            "required": [
              "data",
              "meta"
            ],
            "properties": {
              "data": {
                "type": "object",
                "properties": {
                  "id": {
                    "type": "string",
                    "format": "uuid",
                    "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
                  },
                  "provider": {
                    "type": "string"
                  },
                  "compatibleBaseUrl": {
                    "anyOf": [
                      {
                        "type": "string"
                      },
                      {
                        "type": "null"
                      }
                    ]
                  },
                  "providerConfig": {
                    "type": "object",
                    "properties": {
                      "modelIds": {
                        "default": [],
                        "maxItems": 200,
                        "type": "array",
                        "items": {
                          "type": "string",
                          "minLength": 1,
                          "maxLength": 500
                        }
                      },
                      "azureResourceName": {
                        "type": "string",
                        "pattern": "^[a-z0-9][a-z0-9-]{1,62}[a-z0-9]$"
                      },
                      "azureApiVersion": {
                        "type": "string",
                        "pattern": "^(?:v1|preview|\\d{4}-\\d{2}-\\d{2}(?:-preview)?)$"
                      },
                      "azureUseDeploymentBasedUrls": {
                        "type": "boolean"
                      },
                      "awsRegion": {
                        "type": "string",
                        "pattern": "^[a-z]{2}(?:-gov)?-[a-z]+-\\d$"
                      },
                      "googleProject": {
                        "type": "string",
                        "pattern": "^[a-z][a-z0-9-]{4,61}[a-z0-9]$"
                      },
                      "googleLocation": {
                        "type": "string",
                        "pattern": "^[a-z]+(?:-[a-z0-9]+)+$"
                      }
                    },
                    "required": [
                      "modelIds"
                    ],
                    "additionalProperties": false
                  },
                  "label": {
                    "type": "string"
                  },
                  "fingerprint": {
                    "type": "string"
                  },
                  "state": {
                    "type": "string"
                  },
                  "healthCode": {
                    "type": "string"
                  },
                  "lastValidatedAt": {
                    "anyOf": [
                      {
                        "type": "string",
                        "format": "date-time",
                        "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$"
                      },
                      {
                        "type": "null"
                      }
                    ]
                  },
                  "lastUsedAt": {
                    "anyOf": [
                      {
                        "type": "string",
                        "format": "date-time",
                        "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$"
                      },
                      {
                        "type": "null"
                      }
                    ]
                  },
                  "createdAt": {
                    "type": "string",
                    "format": "date-time",
                    "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$"
                  }
                },
                "required": [
                  "id",
                  "provider",
                  "compatibleBaseUrl",
                  "providerConfig",
                  "label",
                  "fingerprint",
                  "state",
                  "healthCode",
                  "lastValidatedAt",
                  "lastUsedAt",
                  "createdAt"
                ],
                "additionalProperties": false
              },
              "meta": {
                "type": "object",
                "additionalProperties": true,
                "required": [
                  "requestId",
                  "schemaVersion",
                  "buildVersion",
                  "generatedAt",
                  "freshness"
                ],
                "properties": {
                  "requestId": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "schemaVersion": {
                    "type": "string"
                  },
                  "buildVersion": {
                    "type": "string"
                  },
                  "generatedAt": {
                    "type": "string",
                    "format": "date-time"
                  },
                  "freshness": {
                    "type": "object",
                    "additionalProperties": false,
                    "required": [
                      "projectedAt",
                      "sourceWatermark"
                    ],
                    "properties": {
                      "projectedAt": {
                        "type": [
                          "string",
                          "null"
                        ],
                        "format": "date-time"
                      },
                      "sourceWatermark": {
                        "type": [
                          "string",
                          "null"
                        ]
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    },
    "400": {
      "description": "invalid request",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "401": {
      "description": "unauthenticated",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "403": {
      "description": "forbidden",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "404": {
      "description": "not found",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "409": {
      "description": "conflict",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "422": {
      "description": "configuration missing",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "500": {
      "description": "internal error",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    }
  },
  "x-auth-mode": "required-user",
  "x-cache-policy": "none",
  "x-required-scopes": [],
  "x-rate-cost": 1,
  "x-stability": "STABLE"
}